from flask import Flask, jsonify, request, redirect, render_template
from supabase import create_client, Client
import string
import random
from datetime import datetime, timezone

app = Flask(__name__)

# Configuration Supabase
app.config['SUPABASE_URL'] = "https://bvhncawtvkyxoczjojhu.supabase.co"
app.config['SUPABASE_KEY'] = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJzdXBhYmFzZSIsInJlZiI6ImJ2aG5jYXd0dmt5eG9jempvamh1Iiwicm9sZSI6ImFub24iLCJpYXQiOjE3MTcyNTA1NTAsImV4cCI6MjAzMjgyNjU1MH0.eE_p7tsXFQtawrk2QBvNC_H_JoiRyhtjHFBakSYTl5s"
supabase: Client = create_client(app.config['SUPABASE_URL'], app.config['SUPABASE_KEY'])

class URLShortener:
    def __init__(self):
        self.short_url_prefix = "https://www.azurl.me/"
        self.chars = string.ascii_letters + string.digits

    def generate_short_path(self, length=5):
        """Génère un chemin court aléatoire."""
        return ''.join(random.choice(self.chars) for _ in range(length))

    def shorten_url(self, long_url):
        """Crée une URL courte pour une URL longue donnée et l'enregistre dans la base de données."""
        short_path = self.generate_short_path()
        short_url = self.short_url_prefix + short_path
        current_time = datetime.now(timezone.utc).isoformat()
        try:
            data = supabase.table("urls").insert({
                "short_path": short_path,
                "long_url": long_url,
                "short_url": short_url,
                "created_at": current_time
            }).execute()
            return short_url
        except Exception as e:
            raise RuntimeError(f"Erreur lors de l'enregistrement de l'URL : {e}")

    def retrieve_long_url(self, short_path):
        """Récupère l'URL longue à partir d'un chemin court."""
        try:
            result = supabase.table("urls").select("long_url").eq("short_path", short_path).execute()
            if result.data:
                return result.data[0]['long_url']
            else:
                return None
        except Exception as e:
            raise RuntimeError(f"Erreur lors de la récupération de l'URL : {e}")

url_shortener = URLShortener()

@app.route('/', methods=['GET', 'POST'])
def index():
    short_url = None
    error = None
    if request.method == 'POST':
        long_url = request.form.get('long_url')
        if long_url:
            try:
                short_url = url_shortener.shorten_url(long_url)
            except Exception as e:
                error = str(e)  # Capture l'erreur et passe-la au template
    
    return render_template('index.html', short_url=short_url, error=error)

@app.route('/<short_path>', methods=['GET'])
def redirect_to_long_url(short_path):
    """Redirige vers l'URL longue associée au chemin court."""
    try:
        long_url = url_shortener.retrieve_long_url(short_path)
        if long_url:
            return redirect(long_url)
        else:
            return jsonify({"error": "URL non trouvée"}), 404
    except Exception as e:
        print(f"Erreur lors de la redirection : {e}")
        return jsonify({"error": str(e)}), 500

if __name__ == "__main__":
    app.run(debug=True)
